

#pragma once

#include "SGRT.h"
#include "SGSound.h"
#include "SGUILayer.h"


extern SSoundSystem GSound;


void FSBlit();

FLOAT LayeredSineNoise( FLOAT x );


struct SBInterface : SGUILayer
{
	virtual UBOOL ApplyScissor( mAABB2* rect ){ return TRUE; }
};

struct SBMenu : SBInterface
{
	SBMenu() : Pick( 0 ), Time( 0 ){ TransTimes = mVec2( 1.0f ); }
	void Do();
	StrVec Options;
	INT32 Pick;
	mVec2 Pos;
	FLOAT Time;
};


// effects

struct SBSparkFX
{
	static const UINT32 PartCount = 15;

	SBSparkFX() : State( FALSE ){ Shader = SH_Get( "Shaders/Color.shd" ); }
	void Trigger( mVec2 pos, mVec2 dir, FLOAT mult = 1.0f );
	void Advance( FLOAT delta );
	void Render( const mMatrix& view );

	FLOAT Time;
	UBOOL State;
	mVec2 Pos;
	mVec2 Vel[ PartCount ];
	FLOAT Alpha[ PartCount ];

	ShPtr Shader;
};

struct SBExplodeFX
{
	static const UINT32 StarCount = 3;
	static const UINT32 FlameCount = 5;

	SBExplodeFX();
	void Trigger( mVec2 pos, FLOAT size );
	void DrawSprite( FLOAT angle, FLOAT size, FLOAT alpha );
	void Advance( FLOAT delta );
	void Render( const mMatrix& view );

	FLOAT Time;
	mVec2 Pos;
	FLOAT Size;
	FLOAT StarAngles[ StarCount ];
	FLOAT StarAVel[ StarCount ];
	FLOAT FlameAngles[ FlameCount ];
	FLOAT FlameAVel[ FlameCount ];

	ShPtr Shader;
	STexture Star;
	STexture Flame;
	SSEmitter Sound;
};

