

#pragma once

#include "SBLevel.h"


#define ENDACT_SUCCESS			0
#define ENDACT_RESTART_TIMEOUT	1
#define ENDACT_RESTART_DEATH	2
#define ENDACT_RESTART_MANUAL	3
#define ENDACT_LOADING			4
#define ENDACT_QUITTING			5
#define ENDACT_ENDING			6
#define ENDACT_TOENDING			7

struct SBGame : SBInterface
{
	SBGame( SGClientWindow* win );
	~SBGame();
	void Advance( FLOAT delta );
	void Do();

	TString GetLevelFileName();
	UBOOL HasLevel();
	void LoadLevelByID();

	// global states
	UBOOL Paused;
	UBOOL InGame;
	UBOOL NeedToQuit;
	SBLevel* Level;
	INT32 LevelID;
	FLOAT LevelTime;
	FLOAT LevelStopTime;
	INT32 EndActType;

	// UI
	SBMenu* MainMenu;
	STexture TexNoise;
	SSEmitter SndMusic;
};

