

#pragma once

#include "SBEntities.h"


struct SBLevel : SBInterface
{
	SBLevel( SGClientWindow* win );

	void LoadFromText( const TCHAR* txt );
	void Load( const TCHAR* fname );
	void Unload();
	void Advance( FLOAT delta );

	void Do();

	// camera
	mVec2 CamPos;
	FLOAT CamSize;
	mAABB2 GetCamAABB();
	UBOOL InCamera( const mVec2& pos, FLOAT rad );
	UBOOL InCamera( const mAABB2& box );

	// level info / state
	FLOAT Time;	// for some randomness
	UBOOL DrawUI;
	INT32 Width, Height;
	SBPlayer			Player;
	TArray< UINT32 >	Walls;
	TArray< UINT8 >		Adjacency;
	mPoly2				Lights;
	BltVec				Bullets;
	ClcVec				Collectibles;
	EnemyVec			Enemies;
	FLOAT				Timeout;

	FLOAT RaycastWalls( mVec2 pos, mVec2 dir, FLOAT maxdist );
	INT32 RaycastEnts( mVec2 pos, mVec2 dir, FLOAT& maxdist, INT32 ignore );
	void Shoot( mVec2 pos, mVec2 dir, FLOAT dist, FLOAT time, FLOAT rand, INT32 from );

	// resources
	// - visual
	STexture TexPlayer, TexEnemy;
	STexture TexWall, TexFloor;
	STexture TexFlash, TexCollect, TexColNoise, TexEnemyLight;
	STexture TexWallOvr[ 16 ];
	STexture TexLightmap;
	STexture TexNull;
	FBPtr FBLighting;
	STexture TexLighting;
	FBPtr FBRB;
	STexture TexRB;
	// - audio
	SSEmitter SndPlayerMove;
	SSEmitter SndPlayerTurn;
	SSEmitter SndPlayerShoot;
	SSEmitter SndOrbHit;
};

