

#include "SGEngine.h"

#include "SBGame.h"


SSoundSystem GSound;


DOUBLE FPS = 1.0 / 60.0;

int __stdcall WinMain( void* inst, void* previnst, char* cmdline, int showcmd )
{
	Engine_Init();
	Engine_SetDataDir( "/" );

	SGClientWindow* win = Engine_CreateWindow();

	SRenderSettings rs;
	rs.Width = 1024;
	rs.Height = 768;
	win->Create( "Silver Bullet", rs );

	GSound.Init();

	win->Begin();
	M_SetProcFlags( -1 ); // hack
	M_SetProcFlags( MPDF_ALWAYS );
	SBGame* game = new SBGame( win );
	win->End();
	
	DOUBLE time = Engine_GetTime();
	for(;;)
	{
		win->Begin();
		win->Process();
		SWinEvent ev;
		while( win->GetEvent( ev ) )
		{
			if( ev.Type == ET_Close )
				goto end;
		}

		// a simple 60 fps - limited loop
		GSound.Tick( FPS );
		game->Advance( FPS );
		if( game->NeedToQuit ) goto end;
		game->CurMaterial = &game->MatTexture;
#ifdef _DEBUG
		game->DrawTextRect( TString().Printf( 128, "Frame time: %f ms", ( Engine_GetTime() - time ) * 1000.0 ).CStr(), 0, mFColor( 0.9f, 0.8f, 0.7f ), 0, game->Rect, 14.0f );
#endif

		win->End();
		win->Present();
		
		while( Engine_GetTime() - time < FPS )
		{
			if( ( Engine_GetTime() - time ) * 1000 < 15 )
				SThread::Sleep( 1 );
		}
		time = Engine_GetTime();
	}

end:
	delete game;
	win->End();
	GSound.Destroy();
	win->Destroy();

	Engine_Close();
	return 0;
}
